diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/samd/SAMDService.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/samd/SAMDService.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/samd/SAMDService.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/samd/SAMDService.java	2017-09-22 00:34:47.005692000 +0900
@@ -0,0 +1,788 @@
+package com.android.server.samd;
+
+import android.app.ActivityManager;
+import android.content.ComponentName;
+import android.content.Context;
+import android.content.Intent;
+import android.content.pm.IPackageManager;
+import android.os.AsyncTask;
+import android.os.IBinder;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.service.devicemanagement.Device;
+import android.service.samd.ISAMDListener;
+import android.service.samd.ISAMDService;
+import android.service.samd.SAMDMessage;
+import android.util.ArrayMap;
+import android.util.Log;
+import android.util.SparseArray;
+
+import com.android.server.remote.RemoteService;
+import com.android.server.remote.Sender;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileOutputStream;
+import java.io.FileReader;
+import java.io.IOException;
+import java.nio.channels.FileChannel;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.List;
+import java.util.concurrent.CopyOnWriteArrayList;
+
+/**
+ * Created by sbj on 17. 9. 14.
+ */
+public class SAMDService extends ISAMDService.Stub{
+    private HashMap<String, HashMap<String, List<String>>> ActivityTable = new HashMap<>();
+    //1.appName     2.packageName + MainActivityName ------- related activity
+    private HashMap<String, HashMap<String, List<String>>> ResourceTable = new HashMap<>();
+    //1.appName     2.packageName + ActivityName -------- related ResourceFile
+    public String CURRENT_APP;
+    public String CURRENT_PACKAGE;
+    public String CURRENT_ACTIVITY;
+
+    //Activity Per Resource with duplicate (remote use)
+    public static HashMap<String, ArrayList<String>> resourcesPerActivity;
+
+    //SAMD Stack Call Activity per Device (local use)
+    public static SparseArray<ArrayList<String>> callActivityStackPerDevice;
+
+    //SAMD Stack Call Activity (remote use)
+    public static ArrayList<String> callActivityStack;
+    //SAMD Stack Call Resource (remote use)
+    public static ArrayList<String> callResourceStack;
+
+    //collaboroid
+    public static boolean DUMMY_BIT = true;
+
+    //SAMD Cached device table (local use)
+    public static ArrayList<Device> cachedActivityResourceDevices;
+
+    //SAMD Listener
+    private static ArrayMap<IBinder, ISAMDListener> mSAMDListeners = new ArrayMap<IBinder, ISAMDListener>();
+
+
+    //samd
+    //for Remote De
+    public static int remote_device_number = 0;
+    public static String CURRENT_APP_NAME = "";
+    HashMap<String, String[]> smali$FileList = new HashMap<>();
+
+
+    public static Context mContext;
+
+    public SAMDService(Context context)
+    {
+        mContext = context;
+
+        initSAMDService();
+    }
+    public void initSAMDService(){
+        resourcesPerActivity = new HashMap<String, ArrayList<String>>();
+
+        cachedActivityResourceDevices = new ArrayList<Device>();
+        callActivityStackPerDevice = new SparseArray<ArrayList<String>>();
+        callActivityStack = new ArrayList<String>();
+        callResourceStack = new ArrayList<String>();
+    }
+    //samd
+    public boolean initialARTable(String appName){
+
+        ActivityTable.clear();
+        ResourceTable.clear();
+
+        this.CURRENT_APP = appName;
+
+        File deleteDirectory = new File("/collaboroid/preprocess/");
+        DeleteRecursiveFiles(deleteDirectory);
+
+        File sourceDirectory = new File("/data/collaboroid/preprocess/"+appName);
+        File targetDirectory = new File("/collaboroid/preprocess/"+appName);
+
+        if(targetDirectory.mkdir()){
+            try {
+                Log.d("samd experiment","copy start["+appName+"]");
+                if(copyDirectoryAll(sourceDirectory, targetDirectory)){
+                    Log.d("samd experiment","copy end["+appName+"]");
+                    if(RemoteService.connectedDevices!=null){
+                        Log.d("samd","table initialize");
+                        if(RemoteService.connectedDevices.size()!=0){
+                            for(int i=0; i<RemoteService.connectedDevices.size(); i++){
+                                if(RemoteService.mSender.initializeAR(i, appName)){
+                                    cachedActivityResourceDevices.get(i).dexTable.clear();
+                                    cachedActivityResourceDevices.get(i).resourceTable.clear();
+                                    //remove
+                                    callActivityStackPerDevice.remove(i);
+                                }
+                            }
+                        }
+                    }
+                }
+            }catch(Exception e){
+                e.printStackTrace();
+            }
+        }
+        return true;
+    }
+
+    public boolean initialARTableD(int deviceNum, String appName){
+
+        ActivityTable.clear();
+        ResourceTable.clear();
+
+        this.CURRENT_APP = appName;
+
+        File deleteDirectory = new File("/collaboroid/preprocess/");
+        DeleteRecursiveFiles(deleteDirectory);
+
+        File sourceDirectory = new File("/data/collaboroid/preprocess/"+appName);
+        File targetDirectory = new File("collaboroid/preprocess/"+appName);
+        if(targetDirectory.mkdir()){
+            try {
+                Log.d("samd experiment","start copyDirectory");
+                if(copyDirectoryAll(sourceDirectory, targetDirectory)){
+                    Log.d("samd experiment","end copyDirectory");
+                    RemoteService.mSender.initializeAR(deviceNum, appName);
+                    Device d = cachedActivityResourceDevices.get(deviceNum);
+                    d.dexTable.clear();
+                    d.resourceTable.clear();
+                    //remove
+                    callActivityStackPerDevice.remove(deviceNum);
+                }
+            }catch(Exception e){
+                e.printStackTrace();
+            }
+        }
+        return true;
+    }
+    //sendDexWithActivity
+    public void sendDexActivityD(int deviceNum, String DexFile){
+        getResourcesTable(DexFile);
+        HashMap<String, List<String>> ResourcesRelated = ResourceTable.get(CURRENT_APP);
+        SendDexDynamicAsync sendDexDynamicAsync = new SendDexDynamicAsync(deviceNum, DexFile, ResourcesRelated);
+        sendDexDynamicAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+    }
+    public void sendDexActivity(String DexFile){
+        getResourcesTable(DexFile);
+        HashMap<String, List<String>> ResourcesRelated = ResourceTable.get(CURRENT_APP);
+        for(int j=0 ;j<RemoteService.connectedDevices.size(); j++) {
+            SendDexDynamicAsync sendDexDynamicAsync = new SendDexDynamicAsync(j, DexFile, ResourcesRelated);
+            sendDexDynamicAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+        }
+    }
+    public void preSendDex(String currentActivity, String packageName){
+        CURRENT_ACTIVITY = currentActivity;
+        CURRENT_PACKAGE = packageName;
+        //save ActivityTable Hash from ActivityTable.txt
+        getActivityTable();
+        //add ResourceTable from Resources
+        getResourcesTable(ActivityTable.get(CURRENT_APP).get(CURRENT_PACKAGE+"."+CURRENT_ACTIVITY));
+        //sendActivityResources()
+        HashMap<String, List<String>> MainActivityRelated = ActivityTable.get(CURRENT_APP);
+        List<String> multiDexFile = MainActivityRelated.get(CURRENT_PACKAGE+"."+CURRENT_ACTIVITY);
+
+        HashMap<String, List<String>> ResourcesRelated = ResourceTable.get(CURRENT_APP);
+        // res/drawable , res/layout
+        for(int j=0 ;j<RemoteService.connectedDevices.size(); j++){
+            SendDexAsync sendDexAsync = new SendDexAsync(j, multiDexFile, ResourcesRelated);
+            sendDexAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+        }
+    }
+    public void preSendDexD(int deviceNum, String currentActivity, String packageName){
+
+        CURRENT_ACTIVITY = currentActivity;
+        CURRENT_PACKAGE = packageName;
+        //save ActivityTable Hash from ActivityTable.txt
+        getActivityTable();
+        //add ResourceTable from Resources
+        getResourcesTable(ActivityTable.get(CURRENT_APP).get(CURRENT_PACKAGE+"."+CURRENT_ACTIVITY));
+        //sendActivityResources()
+        HashMap<String, List<String>> MainActivityRelated = ActivityTable.get(CURRENT_APP);
+        List<String> multiDexFile = MainActivityRelated.get(CURRENT_PACKAGE+"."+CURRENT_ACTIVITY);
+
+        HashMap<String, List<String>> ResourcesRelated = ResourceTable.get(CURRENT_APP);
+        // res/drawable , res/layout
+        SendDexAsync sendDexAsync = new SendDexAsync(deviceNum, multiDexFile, ResourcesRelated);
+        sendDexAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+    }
+    public void sendResourcesToLocal(List<String> resourceFiles){
+        RemoteService.mSender.sendResourcesRL(resourceFiles, CURRENT_APP_NAME);
+    }
+
+    public void sendResourcesToRemote(List<String> resourceFiles, String toSendActivityName){
+        for(int i=0; i<RemoteService.connectedDevices.size(); i++){
+            List<String> listResources = checkResourceFile(i, (ArrayList)resourceFiles, toSendActivityName);
+            RemoteService.mSender.sendResourcesLR(i, listResources);
+            addResourceFile(i, listResources);
+        }
+    }
+    public void sendResourcesToRemoteD(int deviceNum, List<String> resourceFiles, String toSendActivityName){
+        List<String> listResources = checkResourceFile(deviceNum, (ArrayList)resourceFiles, toSendActivityName);
+        RemoteService.mSender.sendResourcesLR(deviceNum, listResources);
+        addResourceFile(deviceNum, listResources);
+    }
+    public void launchActivity(String toSendActivityName){
+        for(int i=0; i<RemoteService.connectedDevices.size(); i++){
+            RemoteService.mSender.sendActivity(i, toSendActivityName);
+        }
+    }
+    public void launchActivityD(int deviceNum, String toSendActivityName){
+        RemoteService.mSender.sendActivity(deviceNum, toSendActivityName);
+    }
+    public void launchActivityWithRes(String toSendActivityName, List<String> resourceFiles){
+        for(int i=0; i<RemoteService.connectedDevices.size(); i++){
+            SendDexWithResourceAsync sendDexWithResourceAsync
+                    = new SendDexWithResourceAsync(i,toSendActivityName,resourceFiles);
+            sendDexWithResourceAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+        }
+    }
+    public void launchActivityWithResD(int deviceNum, String toSendActivityName, List<String> resourceFiles){
+        SendDexWithResourceAsync sendDexWithResourceAsync
+                = new SendDexWithResourceAsync(deviceNum,toSendActivityName,resourceFiles);
+        sendDexWithResourceAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+    }
+    public void sendMessageToRemoteD(int deviceNum, String msg){
+        RemoteService.mSender.sendMessageLRD(deviceNum, msg);
+    }
+    public void sendMessageToRemote(String msg){
+        for(int i=0; i<RemoteService.connectedDevices.size(); i++){
+            RemoteService.mSender.sendMessageLRD(i, msg);
+        }
+    }
+    public void sendMessageToLocal(String msg){
+        RemoteService.mSender.sendMessageRL(msg);
+    }
+
+    public int getRemoteDeviceCount() { return RemoteService.connectedDevices.size(); }
+
+    public int getRemoteDeviceNumber() { return this.remote_device_number; }
+
+    public String getCurrentAppName(){
+        return CURRENT_APP_NAME;
+    }
+
+    public void requestSAMDListener(ISAMDListener listener){
+        mSAMDListeners.put(listener.asBinder(), listener);
+    }
+    public static void dispatchMessage(SAMDMessage message){
+        Log.d("mSAMDListeners", "mSAMDListeners size : " + mSAMDListeners.size());
+        for(ISAMDListener l : mSAMDListeners.values()){
+            try {
+                Log.d("mSAMDListeners", "mSAMDListeners write msg : " + message.getMessage());
+                l.onSAMDMsg(message);
+            } catch (RemoteException e) {
+                Log.d("dispatchMessage", "dispatchMessage error");
+            }
+        }
+    }
+
+    public void sendAPKFile(String dir){
+        for(int i=0; i<RemoteService.connectedDevices.size(); i++){
+            SendAPKAsync apkAsync = new SendAPKAsync(i,dir);
+            apkAsync.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
+        }
+
+    }
+    //add resource
+    private synchronized void addResourceFile(int deviceNum, List<String> resourceString){
+        // resourceString :
+        Device d = cachedActivityResourceDevices.get(deviceNum);
+        List<String> temp = d.resourceTable;
+        //remove !
+        for(int i=0; i<resourceString.size(); i++){
+            if(resourceString.get(i).contains("!")){
+                resourceString.set(i, resourceString.get(i).split("!")[1]);
+            }
+        }
+        //duplicate remove
+        for(String s : temp){
+            resourceString.remove(s);
+        }
+        d.resourceTable.addAll(resourceString);
+    }
+
+    //get resource dex
+    private List<String> getDexFile(int deviceNum){
+        Device d = cachedActivityResourceDevices.get(deviceNum);
+        return d.dexTable;
+    }
+
+    private List<String> getResourceFile(int deviceNum){
+        Device d = cachedActivityResourceDevices.get(deviceNum);
+        return d.resourceTable;
+    }
+
+    private synchronized boolean checkDexFile(int deviceNum, String dexFile){
+        List<String> temp = cachedActivityResourceDevices.get(deviceNum).dexTable;
+        return temp.contains(dexFile);
+    }
+
+    private synchronized List<String> checkResourceFile(int deviceNum, ArrayList<String> resourceList, String dexFile){
+        List<String> temp = cachedActivityResourceDevices.get(deviceNum).resourceTable;
+        CopyOnWriteArrayList<String> tempList = new CopyOnWriteArrayList<String>();
+        Iterator it = ((ArrayList<String>)resourceList.clone()).iterator();
+        while(it.hasNext()){
+            tempList.add((String)it.next());
+        }
+        for(int i=0; i<tempList.size(); i++){
+            boolean result = false;
+            for(String s : temp){
+                if(s.replace(s.split("\\/")[0]+"/", "").equals(tempList.get(i))){
+                    //exist
+                    tempList.set(i, "!"+s);
+                    result = true;
+                }
+            }
+            if(!result){
+                //not exist
+                tempList.set(i, dexFile+"/"+tempList.get(i));
+            }
+        }
+        return tempList;
+    }
+
+    public void ConvertDex(String appName){
+        String[] smaliArgs = {"-o",
+                "/reviseApp/"+appName+"/dexes/classes.dex",
+                "--",
+                "/reviseApp/"+appName+"/smalis"};
+        //com.android.smali.main.main(smaliArgs);
+        IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+        try {
+            pm.aaptAdd(2, "/system/priv-app/"+appName+"/"+appName+".apk", "classes.dex");
+            pm.aaptAdd(1, "/system/priv-app/"+appName+"/"+appName+".apk", "/reviseApp/"+appName+"/dexes/classes.dex");
+        } catch (RemoteException e) {
+            e.printStackTrace();
+        }
+    }
+
+    public synchronized void popUpActivity(String activityName){
+        //abc.apk exists?
+        IPackageManager pm = IPackageManager.Stub.asInterface(ServiceManager.getService("package"));
+        synchronized (this){
+            try{
+                File f = new File("/collaboroid/agent/activity_res/"+activityName+"/abc.apk");
+                File dst_f = new File("/collaboroid/agent/abc.apk");
+                copy(f, dst_f);
+
+                if(DUMMY_BIT){
+                    Log.d("samd experiment","aapt add/remove start["+activityName+"]");
+                    pm.aaptAdd(2, "/system/priv-app/Dummy1/Dummy1.apk", "classes.dex");
+                    File dexFile_ = new File("/collaboroid/agent/dex/" + activityName + "_classes.dex");
+                    File classesDex = new File("/collaboroid/agent/dex/classes.dex");
+                    dexFile_.renameTo(classesDex);
+                    pm.aaptAdd(1, "/system/priv-app/Dummy1/Dummy1.apk", "/collaboroid/agent/dex/classes.dex");
+                    classesDex.renameTo(dexFile_);
+                    Log.d("samd experiment","aapt add/remove end["+activityName+"]");
+
+
+                    ComponentName compName = new ComponentName(
+                            "com.collaboroid.dummy1", "com.collaboroid.dummy1.MainActivity");
+                    Intent intent = new Intent(Intent.ACTION_MAIN);
+                    intent.setComponent(compName);
+                    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                    intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);
+                    intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
+
+
+                    mContext.startActivity(intent);
+
+                    DUMMY_BIT = !DUMMY_BIT;
+
+                    ActivityManager activityManager = (ActivityManager) mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                    List<ActivityManager.RunningAppProcessInfo> pidsTask = activityManager.getRunningAppProcesses();
+                    for (int i = 0; i < pidsTask.size(); i++) {
+                        if (pidsTask.get(i).processName.equals("com.collaboroid.dummy2")) {
+                            android.os.Process.killProcess(pidsTask.get(i).pid);
+                        }
+                    }
+                    callResourceStack.remove(activityName);
+                }else{
+                    Log.d("samd experiment","aapt add/remove start["+activityName+"]");
+                    pm.aaptAdd(2, "/system/priv-app/Dummy2/Dummy2.apk", "classes.dex");
+                    File dexFile_ = new File("/collaboroid/agent/dex/" + activityName + "_classes.dex");
+                    File classesDex = new File("/collaboroid/agent/dex/classes.dex");
+                    dexFile_.renameTo(classesDex);
+                    pm.aaptAdd(1, "/system/priv-app/Dummy2/Dummy2.apk", "/collaboroid/agent/dex/classes.dex");
+                    classesDex.renameTo(dexFile_);
+                    Log.d("samd experiment","aapt add/remove end["+activityName+"]");
+
+                    ComponentName compName = new ComponentName(
+                            "com.collaboroid.dummy2", "com.collaboroid.dummy2.MainActivity");
+                    Intent intent = new Intent(Intent.ACTION_MAIN);
+                    intent.setComponent(compName);
+                    intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                    intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);
+                    intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
+
+                    mContext.startActivity(intent);
+                    DUMMY_BIT = !DUMMY_BIT;
+
+                    ActivityManager activityManager = (ActivityManager) mContext.getSystemService(Context.ACTIVITY_SERVICE);
+                    List<ActivityManager.RunningAppProcessInfo> pidsTask = activityManager.getRunningAppProcesses();
+                    for (int i = 0; i < pidsTask.size(); i++) {
+                        if (pidsTask.get(i).processName.equals("com.collaboroid.dummy1")) {
+                            android.os.Process.killProcess(pidsTask.get(i).pid);
+                        }
+                    }
+
+                    callResourceStack.remove(activityName);
+                }
+            }catch (Exception e){
+                e.printStackTrace();
+            }
+        }
+
+    }
+    public static void copy(File src, File dst) throws IOException{
+
+        FileInputStream in = new FileInputStream(src);
+        FileOutputStream out = new FileOutputStream(dst);
+
+
+
+        FileChannel inChannel = in.getChannel();
+        FileChannel outChannel = out.getChannel();
+        inChannel.transferTo(0, inChannel.size(), outChannel);
+        inChannel.close();
+        outChannel.close();
+
+    }
+    private void DeleteRecursiveFiles(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+
+    }
+
+    private void DeleteRecursive(File fileOrDirectory) {
+
+        if (fileOrDirectory.isDirectory())
+            for (File child : fileOrDirectory.listFiles())
+                DeleteRecursive(child);
+
+        fileOrDirectory.delete();
+    }
+    class SendDexWithResourceAsync extends AsyncTask<Void,Void,Boolean> {
+        int deviceNum;
+        String DexFile;
+        List<String> ResourcesRelated;
+        public SendDexWithResourceAsync(int deviceNum, String DexFile, List<String> ResourcesRelated){
+            this.deviceNum = deviceNum;
+            this.DexFile = DexFile;
+            this.ResourcesRelated = ResourcesRelated;
+        }
+        @Override
+        protected void onPreExecute() {
+            super.onPreExecute();
+        }
+
+        @Override
+        protected Boolean doInBackground(Void... voids) {
+
+            boolean result = false;
+            if(!checkDexFile(deviceNum, DexFile)){
+                List<String> listResources = checkResourceFile(deviceNum, (ArrayList)ResourcesRelated, DexFile);
+                result = RemoteService.mSender.sendActivityWithRes(deviceNum, DexFile, listResources);
+                addResourceFile(deviceNum, listResources);
+            }
+            return result;
+        }
+
+        // AsyncTask.cancel(boolean) 메소드가 true 인자로
+        // 실행되면 호출되는 콜백.
+        // background 작업이 취소될때 꼭 해야될 작업은  여기에 구현.
+        @Override
+        protected void onCancelled() {
+            // TODO Auto-generated method stub
+            super.onCancelled();
+        }
+    }
+    class SendDexAsync extends AsyncTask<Void,Void,Boolean> {
+        int deviceNum;
+        List<String> DexFile;
+        HashMap<String, List<String>> ResourcesRelated;
+        public SendDexAsync(int deviceNum, List<String> DexFile, HashMap<String, List<String>> ResourcesRelated){
+            this.deviceNum = deviceNum;
+            this.DexFile = DexFile;
+            this.ResourcesRelated = ResourcesRelated;
+        }
+        @Override
+        protected void onPreExecute() {
+            super.onPreExecute();
+        }
+
+        @Override
+        protected Boolean doInBackground(Void... voids) {
+
+            boolean result = false;
+
+            if(DexFile.contains("")){
+                DexFile.remove("");
+            }
+            if(DexFile.size() != 0){
+                //compare cached dex to last aapt
+                //remove??
+                //dex and resourse dependancy
+                for(int i=0; i<DexFile.size(); i++){
+                    List<String> resourcesFiles = ResourcesRelated.get(CURRENT_PACKAGE+"."+DexFile.get(i));
+                    //send Dex
+
+                    List<String> values = new ArrayList<>();
+                    File valuesDirectory = new File("/collaboroid/preprocess/"+CURRENT_APP+"/res/values");
+                    for (File child : valuesDirectory.listFiles()) {
+                        values.add("res/values/"+child.getName());
+                    }
+                    values.add("res/drawable/ic_launcher.png");
+                    resourcesFiles.addAll(values);
+                    if(!checkDexFile(deviceNum, DexFile.get(i))){
+                        List<String> listResources = checkResourceFile(deviceNum, (ArrayList)resourcesFiles, DexFile.get(i));
+                        result = RemoteService.mSender.sendDex(deviceNum, DexFile.get(i), listResources);
+                        addResourceFile(deviceNum, listResources);
+                    }
+                }
+            }
+
+            return result;
+        }
+
+
+        // AsyncTask.cancel(boolean) 메소드가 true 인자로
+        // 실행되면 호출되는 콜백.
+        // background 작업이 취소될때 꼭 해야될 작업은  여기에 구현.
+        @Override
+        protected void onCancelled() {
+            // TODO Auto-generated method stub
+            super.onCancelled();
+        }
+    }
+    class SendDexDynamicAsync extends AsyncTask<Void,Void,Boolean> {
+        int deviceNum;
+        String DexFile;
+        HashMap<String, List<String>> ResourcesRelated;
+        public SendDexDynamicAsync(int deviceNum, String DexFile, HashMap<String, List<String>> ResourcesRelated){
+            this.deviceNum = deviceNum;
+            this.DexFile = DexFile;
+            this.ResourcesRelated = ResourcesRelated;
+        }
+        @Override
+        protected void onPreExecute() {
+            super.onPreExecute();
+        }
+
+        @Override
+        protected Boolean doInBackground(Void... voids) {
+
+            boolean result = false;
+            //compare cached dex to last aapt
+            //remove??
+            //dex and resourse dependancy
+            List<String> resourcesFiles = ResourcesRelated.get(CURRENT_PACKAGE + "." + DexFile);
+            //send Dex
+
+            List<String> values = new ArrayList<>();
+            File valuesDirectory = new File("/collaboroid/preprocess/"+CURRENT_APP+"/res/values");
+            for (File child : valuesDirectory.listFiles()) {
+                values.add("res/values/"+child.getName());
+            }
+            values.add("res/drawable/ic_launcher.png");
+            resourcesFiles.addAll(values);
+            if (!checkDexFile(deviceNum, DexFile)) {
+                List<String> listResources = checkResourceFile(deviceNum, (ArrayList)resourcesFiles, DexFile);
+                Log.d("samd experiment", "start Dex & Resources : " + DexFile + " to " + (deviceNum + 1));
+                result = RemoteService.mSender.sendDexActivity(deviceNum, DexFile, listResources);
+                addResourceFile(deviceNum, listResources);
+            }
+            return result;
+        }
+
+
+        // AsyncTask.cancel(boolean) 메소드가 true 인자로
+        // 실행되면 호출되는 콜백.
+        // background 작업이 취소될때 꼭 해야될 작업은  여기에 구현.
+        @Override
+        protected void onCancelled() {
+            // TODO Auto-generated method stub
+            super.onCancelled();
+        }
+    }
+    class SendAPKAsync extends AsyncTask<Void,Void,Boolean> {
+        int deviceNum;
+        String dir;
+        public SendAPKAsync(int deviceNum, String dir){
+            this.deviceNum = deviceNum;
+            this.dir = dir;
+        }
+        @Override
+        protected void onPreExecute() {
+            super.onPreExecute();
+        }
+
+        @Override
+        protected Boolean doInBackground(Void... voids) {
+            String dir_temp = "/system/priv-app/"+dir+"/"+dir+".apk";
+            RemoteService.mSender.sendAPKFile(deviceNum, dir_temp);
+            return true;
+        }
+
+
+        // AsyncTask.cancel(boolean) 메소드가 true 인자로
+        // 실행되면 호출되는 콜백.
+        // background 작업이 취소될때 꼭 해야될 작업은  여기에 구현.
+        @Override
+        protected void onCancelled() {
+            // TODO Auto-generated method stub
+            super.onCancelled();
+        }
+    }
+    private void getActivityTable(){
+        // read file and find appName -> packageName + mainActivityName ---- a,b,c,d,e
+        // create ArrayList<relatedActivity>  put a,b,c,d,e
+        // create Hashmap<packageName + mainActivityname , ArrayList<relatedActivity>> and put
+        // ActivityTable<appName, up HashMap> put
+        HashMap<String, List<String>> relatedActivity = new HashMap<>();
+        List<String> activities = new ArrayList<>();
+
+        File file = new File("/data/collaboroid/preprocess/"+CURRENT_APP+"/ActivityTable.txt");
+        BufferedReader br = null;
+        try {
+            br = new BufferedReader(new FileReader(file));
+            String line;
+            while ((line = br.readLine()) != null) {
+                String[] temp = line.toString().trim().split("\\@");
+                if(temp[0].equals(CURRENT_PACKAGE+"."+CURRENT_ACTIVITY)){
+                    for(int i=1; i<temp.length; i++){
+                        if(!activities.contains(temp[i]))
+                            activities.add(i-1, temp[i]);
+                    }
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        } finally {
+            try {
+                if (br != null)
+                    br.close();
+            } catch (IOException e) {
+                //
+            }
+        }
+
+        relatedActivity.put(CURRENT_PACKAGE+"."+CURRENT_ACTIVITY, activities);
+        ActivityTable.put(CURRENT_APP, relatedActivity);
+
+    }
+    private void getResourcesTable(String activitie){
+        // read file and find appName -> packageName + mainActivityName ---- a,b,c,d,e
+        // create ArrayList<relatedResources>  put a.png, b.xml, c.png, d.png, e.xml
+        // create Hashmap<packageName + mainActivityname , ArrayList<relatedActivity>> and put
+        // ActivityTable<appName, up HashMap> put
+        HashMap<String, List<String>> relatedResource = new HashMap<>();
+
+        File file = new File("/data/collaboroid/preprocess/"+CURRENT_APP+"/ResourceTable.txt");
+        BufferedReader br = null;
+        List<String> resources = new ArrayList<>();
+        try {
+            br = new BufferedReader(new FileReader(file));
+            String line;
+            while ((line = br.readLine()) != null) {
+                String[] temp = line.toString().trim().split("\\@");
+                if(temp[0].equals(CURRENT_PACKAGE+"."+activitie)){
+                    for(int j=1; j<temp.length; j++){
+                        if(!resources.contains(temp[j]))
+                            resources.add(j-1, temp[j]);
+                    }
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+        } finally {
+            try {
+                if (br != null)
+                    br.close();
+            } catch (IOException e) {
+                //
+            }
+        }
+
+        relatedResource.put(CURRENT_PACKAGE+"."+activitie, resources);
+        ResourceTable.put(CURRENT_APP, relatedResource);
+    }
+
+    private void getResourcesTable(List<String> activities){
+        // read file and find appName -> packageName + mainActivityName ---- a,b,c,d,e
+        // create ArrayList<relatedResources>  put a.png, b.xml, c.png, d.png, e.xml
+        // create Hashmap<packageName + mainActivityname , ArrayList<relatedActivity>> and put
+        // ActivityTable<appName, up HashMap> put
+        HashMap<String, List<String>> relatedResource = new HashMap<>();
+
+        File file = new File("/data/collaboroid/preprocess/"+CURRENT_APP+"/ResourceTable.txt");
+
+        BufferedReader br = null;
+        for(int i=0; i<activities.size(); i++){
+            List<String> resources = new ArrayList<>();
+            try {
+                br = new BufferedReader(new FileReader(file));
+                String line;
+                while ((line = br.readLine()) != null) {
+                    String[] temp = line.toString().trim().split("\\@");
+                    if(temp[0].equals(CURRENT_PACKAGE+"."+activities.get(i))){
+                        for(int j=1; j<temp.length; j++){
+                            resources.add(j-1, temp[j]);
+                        }
+                    }
+                }
+            } catch (Exception e) {
+                e.printStackTrace();
+            } finally {
+                try {
+                    if (br != null)
+                        br.close();
+                } catch (IOException e) {
+                    //
+                }
+            }
+
+            HashSet hs = new HashSet(resources);
+            List<String> newResources= new ArrayList<>(hs);
+
+
+            relatedResource.put(CURRENT_PACKAGE+"."+activities.get(i), resources);
+        }
+
+        ResourceTable.put(CURRENT_APP, relatedResource);
+    }
+
+    private boolean copyDirectoryAll(File sourceLocation, File targetLoacation) throws IOException {
+
+        //source is directory
+        if(sourceLocation.isDirectory()){
+            if(!targetLoacation.exists()){
+                targetLoacation.mkdir();
+            }
+            String[] children = sourceLocation.list();
+            for(int i=0; i<children.length; i++){
+                copyDirectoryAll(new File(sourceLocation, children[i]), new File(targetLoacation, children[i]));
+            }
+        }
+
+        else{
+            FileInputStream in = new FileInputStream(sourceLocation);
+            FileOutputStream out = new FileOutputStream(targetLoacation);
+
+            FileChannel inChannel = in.getChannel();
+            FileChannel outChannel = out.getChannel();
+            inChannel.transferTo(0, inChannel.size(), outChannel);
+            inChannel.close();
+            outChannel.close();
+
+        }
+        return true;
+    }
+}
